create procedure [dbo].[NaplneniTolerance4]
/*deklarovani mistnich promenych*/
@jmeno_katIN varchar(100),
@typ_normyIN varchar(10),
@kod_normyIN varchar(15),
@strojIN varchar(50),
@jmeno_omezeniIN varchar(30),
@jmeno_oznaceniIN varchar(100),
@tolerance varchar(20),
@platnostIN bit,
@popisIN varchar(500),


@kod_normyID varchar(15) output,
@typ_normyID numeric(3) output,
@strojID numeric(3) output,
@kategorieID numeric(3) output,
@omezeniID numeric(3) output,
@oznaceniID numeric(3) output

AS

begin transaction
/* pridani stroje (pokud neexistuje) a nacteni id*/
if exists (select typ_stroje from stroj where typ_stroje = @strojIN )
	begin
		select @strojID = id_stroje from stroj
		where typ_stroje = @strojIN
		
	end
else
	begin
	select @strojID = MAX(id_stroje) from stroj
	set @strojID = @strojID + 1
	insert into stroj values 
	(@strojID,@strojIN, null)
	
	end

/* pridani kategorie (pokud neexistuje) a nacteni id*/
if exists (select jmeno_kat from kategorie where jmeno_kat = @jmeno_katIN )
	begin /*pokud uz exstuje tak nacte ID*/
		select @kategorieID = id_kategorie from kategorie
		where jmeno_kat = @jmeno_katIN
		
	end
else
	begin  /*zvysi id o jedna a ulozi do tabulky*/
	select @kategorieID = MAX(id_kategorie) from kategorie
	set @kategorieID = @kategorieID + 1
	insert into kategorie values 
	(@kategorieID,@jmeno_katIN, null)
	
	end


/* pridani omezeni (pokud neexistuje) a nacteni id*/
if exists (select jmeno_omezeni from omezeni where jmeno_omezeni = @jmeno_omezeniIN )
	begin /*pokud uz exstuje tak nacte ID*/
		select @omezeniID = id_omezeni from omezeni
		where jmeno_omezeni = @jmeno_omezeniIN
	end
else
	begin /*zvysi id o jedna a ulozi do tabulky*/
		select @omezeniID = MAX(id_omezeni) from omezeni
		set @omezeniID = @omezeniID + 1
		insert into omezeni values 
		(@omezeniID,@jmeno_omezeniIN)
		
	end


/* pridani oznaceni (pokud neexistuje) a nacteni id*/


if exists (select jmeno_oznaceni from oznaceni where jmeno_oznaceni = @jmeno_oznaceniIN )
	begin /*pokud uz exstuje tak nacte ID*/
		select @oznaceniID = id_oznaceni from oznaceni
		where jmeno_oznaceni = @jmeno_oznaceniIN
		
	end
else
	begin /*zvysi id o jedna a ulozi do tabulky*/
		select @oznaceniID = MAX(id_oznaceni) from oznaceni
		set @oznaceniID = @oznaceniID + 1
		insert into oznaceni values 
		(@oznaceniID,@jmeno_oznaceniIN)
		
	end


/* pridani normy vcetne typu_normy (pokud neexistuje) a nacteni id*/

if exists (select kod_normy, typ_normy from norma join typ_normy
ON norma.id_typ_normy = typ_normy.id_typ_normy 
and @kod_normyIN = kod_normy
and @typ_normyIN = typ_normy
)
	begin /*pokud uz exstuje tak nacte ID*/
		select @typ_normyID = id_typ_normy from typ_normy
		where typ_normy = @typ_normyIN	
		select @kod_normyID = kod_normy from norma
		where kod_normy = @kod_normyIN
		
	end
else
	begin 
		if exists (select typ_normy from typ_normy where typ_normy = @typ_normyIN )
			begin /*pokud uz exstuje tak nacte ID*/
				select @typ_normyID = id_typ_normy from typ_normy 
				where typ_normy = @typ_normyIN
			end
		else
			begin
				 /*zvysi id o jedna a ulozi do tabulky*/
				select @typ_normyID = MAX(id_typ_normy) from typ_normy
				set @typ_normyID = @typ_normyID + 1
				insert into typ_normy values 
				(@typ_normyID,@typ_normyIN, null)
				
					
			end
		insert into norma values
		(@typ_normyID,@kod_normyIN,@platnostIN,null)
		select @kod_normyID = kod_normy from norma
		where kod_normy = @kod_normyIN
			
	end

/*ulozeni do tolerance*/

if not exists 
	(select * from tolerance 
	where
	id_kategorie = @kategorieID
	and id_omezeni = @omezeniID
	and id_oznaceni = @oznaceniID
	and kod_normy = @kod_normyID
	and id_stroje = @strojID
	and tolerance = @tolerance)
	
	begin
		insert into tolerance values
		(@kategorieID, @omezeniID, @oznaceniID, @kod_normyID, @strojID, @tolerance, null)
	end
else
	begin
	print 'V databazi je uz zznam'
	end

if not exists (select * from popis_tolerance where id_oznaceni = @oznaceniID and id_stroje = @strojID and popis = @popisIN)
begin
	insert into popis_tolerance values 
	(@strojID, @oznaceniID, @popisIN)
end
commit

